# -*- coding: utf-8 -*-
"""
Created on Tue Oct 31 14:52:10 2023

@author: vlandgraf
"""

# -*- coding: utf-8 -*-
"""
Created on Fri Oct 20 10:46:36 2023

@author: vlandgraf


"""



from pymatgen.io.vasp import Vasprun
import general_AF_structure_analysis
import pickle as pkl
import numpy as np
import os
import glob
from pymatgen.io.vasp.outputs import Poscar



with open('./jump_lib_LNCl_ACTUAL.pkl', 'rb') as h: 
    d = pkl.load(h)

#Make a dictionary that sorts the jumps by bottleneck and jump type

tet_oct_jumps = {}
oct_tet_jumps = {}
tet_tet_jumps = {}

for k,v in d.items(): 
    if v['jump_type'] =='tet-oct':
        if v['BN'] in tet_oct_jumps.keys(): 
            tet_oct_jumps[v['BN']][0].append(v['average_ea'])
        else:
            tet_oct_jumps[v['BN']] = []
            tet_oct_jumps[v['BN']].append([v['average_ea']])
    elif v['jump_type'] =='oct-tet':
        if v['BN'] in oct_tet_jumps.keys(): 
            oct_tet_jumps[v['BN']][0].append(v['average_ea'])
        else:
            oct_tet_jumps[v['BN']] = []
            oct_tet_jumps[v['BN']].append([v['average_ea']])
    elif v['jump_type'] =='tet-tet':
        if v['BN'] in tet_tet_jumps.keys(): 
            tet_tet_jumps[v['BN']][0].append(v['average_ea'])
        else:
            tet_tet_jumps[v['BN']] = []
            tet_tet_jumps[v['BN']].append([v['average_ea']])

for i in [tet_oct_jumps, oct_tet_jumps, tet_tet_jumps]: 
    
    for k,v in i.items(): 
        v.append(np.average(v[0]))
        v.append(np.std(v[0])/len(v[0]))

'''
Get bottleneck size
Using the 5 structures that I used for AIMD
'''


with open('BN_sizes_dictionary.pkl', 'rb') as h: 
    bottleneck_d = pkl.load(h)






import matplotlib.pyplot as plt

fig,ax = plt.subplots(1,1, figsize=(3, 3*2/3), dpi = 300)



marker = 'o'
ms = 5
lw = 0.6
ls = '-'
label_size = 9
tick_size = 8
x_axis = [1,2,3,4]
x_axis_label = ['ClClCl', 'ClClN', 'ClNN', 'NNN']
ax.errorbar(x_axis, [tet_oct_jumps[i][1] for i in x_axis_label], yerr = [tet_oct_jumps[i][-1] for i in x_axis_label],
            marker='s', linestyle = ls, lw=lw, ms = ms,label = 'tet-oct', mec='black' , c='cornflowerblue')
ax.errorbar(x_axis, [oct_tet_jumps[i][1] for i in x_axis_label], yerr = [oct_tet_jumps[i][-1] for i in x_axis_label],
            marker='s', linestyle = ls, lw=lw, ms = ms,label = 'oct-tet' , mec='black', c = 'orange')
ax.set_xticks(x_axis, x_axis_label, size = tick_size)
ax.set_ylabel('jump-Ea (eV)', size = label_size)
ax.set_xlabel('Type of bottleneck', size = label_size)
ax.tick_params(axis='both', direction='in', labelsize = tick_size) 
ax2 = ax.twinx()
y_bneck_size = [bottleneck_d[i+'_modified_average'] for i in x_axis_label]
y_bneck_error = [bottleneck_d[i+'_modified_error'] for i in x_axis_label]
# y_bneck_2 = [bottleneck_d[i+'_average'] for i in x_axis_label]

ax2.errorbar(x_axis, np.array(y_bneck_size)*2, yerr = y_bneck_error, marker='o', linestyle = ls, lw=lw, ms = ms, c='limegreen', mec='black')
ax2.tick_params(axis='both', direction='in', labelsize = tick_size) 
# ax2.errorbar(x_axis, np.array(y_bneck_2)*2, yerr = y_bneck_error, marker='o', linestyle = ls, lw=lw, ms = ms, c='lightslategray', mec='black')
ax2.set_ylabel('Bottlenekck diameter (Å)')
ax2.set_ylim(0.6, 2)
ax.set_ylim(0.23, 0.5)

plt.savefig('Bottleneck_figure_for_LNCl.eps', format = 'eps', bbox_inches='tight')
plt.savefig('TEMP_Bottleneck_figure_for_LNCl.png', format = 'png', bbox_inches='tight')


#Now same for the tet-tet jumps

fig,ax = plt.subplots(1,1, figsize=(3, 3*2/3), dpi = 300)


marker = 'o'
ms = 5
lw = 0.6
ls = '-'
label_size = 9
tick_size = 8
x_axis = [1,2,3]
x_axis_label = ['ClCl', 'ClN', 'NN']


ax.errorbar(x_axis, [tet_tet_jumps[i][1] for i in x_axis_label], yerr = [tet_tet_jumps[i][-1] for i in x_axis_label],
            marker='s', linestyle = ls, lw=lw, ms = ms,label = 'tet-tet', mec='black' , c='cornflowerblue')



ax.set_xticks(x_axis, x_axis_label, size = tick_size)
ax.set_ylabel('jump-Ea (eV)', size = label_size)
ax.set_xlabel('Type of bottleneck', size = label_size)
ax.tick_params(axis='both', direction='in', labelsize = tick_size) 
ax2 = ax.twinx()
y_bneck_size = [bottleneck_d[i+'_modified_average'] for i in x_axis_label]
y_bneck_error = [bottleneck_d[i+'_modified_error'] for i in x_axis_label]

ax2.errorbar(x_axis, np.array(y_bneck_size)*2, yerr = y_bneck_error, marker='o', linestyle = ls, lw=lw, ms = ms, c='limegreen', mec='black')
ax2.tick_params(axis='both', direction='in', labelsize = tick_size) 
# ax2.errorbar(x_axis, np.array(y_bneck_2)*2, yerr = y_bneck_error, marker='o', linestyle = ls, lw=lw, ms = ms, c='lightslategray', mec='black')
ax2.set_ylabel('Bottlenekck diameter (Å)')
ax2.set_ylim(0.35, 2.3)


plt.savefig('TET_Bottleneck_figure_for_LNCl.eps', format = 'eps', bbox_inches='tight')
