# -*- coding: utf-8 -*-
"""
Created on Wed Nov  8 12:12:38 2023

@author: vlandgraf
"""

import pymatgen
from pymatgen.core import Structure
import networkx as nx
import pickle as pkl
from pymatgen.io.vasp.inputs import Poscar
import copy
import numpy as np
import general_AF_structure_analysis
import Functions_for_network_analysis as Ffn
import time
from pymatgen.io.cif import CifWriter




indices_dictionary = {}

structures = []
for i in range(10000):
    s = Structure.from_file('Cif_files/'+str(i)+'.cif')
    structures.append(s)
    
    if s.composition in indices_dictionary.keys(): 
        indices_dictionary[s.composition].append(i)
        
    else:
        indices_dictionary[s.composition] = [i]



comp_keys = []

dictionary_for_energy_percolation_diagram = {}


for e_a in np.linspace(0.32, 0.54, 23):
    with open('Storage_dicts/Storage_dicts/TEST_storage_dictionary_lncl_{}.pkl'.format(np.round(e_a,2)), 'rb') as h:
        d = pkl.load(h)
        
        for comp in d.keys():
            
            if comp not in dictionary_for_energy_percolation_diagram.keys():
                dictionary_for_energy_percolation_diagram[comp] = {'e_a':  [], 'fraction': [], 'fraction_error' : []}
            dictionary_for_energy_percolation_diagram[comp]['e_a'].append(e_a)
            dictionary_for_energy_percolation_diagram[comp]['fraction'].append(d[comp]['average_fraction_of_Li'])
            dictionary_for_energy_percolation_diagram[comp]['fraction_error'].append(d[comp]['average_fraction_error'])
        del d
with open('dictionary_for_fraction_plotting.pkl', 'wb') as h:
    pkl.dump(dictionary_for_energy_percolation_diagram, h)
%matplotlib auto
import matplotlib.pyplot as plt 
labels = [str(15/32), str(13/32), str(12/32), str(16/32), str(11/32), str(14/32)]
count = -1
for k,v in dictionary_for_energy_percolation_diagram.items():
    count+=1
    plt.plot(v['e_a'],v['fraction'], label = labels[count])
    plt.legend()           
            
# with open('jump_lib_LNCl_ACTUAL.pkl', 'rb') as h:
    
#     d = pkl.load(h)    
    
# for k,v in d.items():
#     if v['jump_type']=='tet-oct':
#         print(v['activation_energies'][:10])
        
        
        
        
# with open('Storage_dicts/Storage_dicts/TEST_storage_dictionary_lncl_0.32.pkl', 'rb') as h:
#     d = pkl.load(h)
    
# d['Na+32 Li+64 N3-11 Cl-21']['fraction_of_active_Li_sites']