import pymatgen
import copy
from pymatgen.symmetry.analyzer import SpacegroupAnalyzer, SpacegroupOperations
from pymatgen.core import Structure, Lattice
from pymatgen.io.vasp.outputs import Poscar
import pymatgen
from pymatgen.core.structure import Structure
import copy
import math
from math import sqrt
import pymatgen.io.vasp.inputs as vasp_inputs
import pymatgen.io.cif
import numpy
import pandas
import pymatgen
import pickle as pkl
import numpy as np
import matplotlib.pyplot as plt
from pymatgen.io.cif import CifWriter
import pandas
import pymatgen
import pickle as pkl
import numpy as np


def find_tet_for_Li(my_srtucture):
    my_srtucture=copy.deepcopy(my_srtucture)
    list_of_Li_sites = [i for i,j in enumerate(my_srtucture) if j.specie.name == 'Li']
    init, end = list_of_Li_sites[0], list_of_Li_sites[-1]
    dim = numpy.max(my_srtucture.lattice.abc)
    Li_neighbors = my_srtucture.get_all_neighbors(dim, include_image=True)[init:end+1]
    #print(init, end+1, 'Lithium HEREEEEEEEEEEE')
    #Li_neighbors = neighbors[init:end+1]
    Li_counter = 0

    #global list_of_dictionary_of_Li_tetrahedra
    list_of_dictionary_of_Li_tetrahedra = []

    for li_index, i in enumerate(Li_neighbors):
        # sort to get the shortest distance first
        i.sort(key = lambda x: x[0][1])
        #global tmp_list
        tmp_list = []

        index=0

        while len(tmp_list) != 4:

            if i[index][0].specie.name != "Li" and i[index][0].specie.name != "Na":
                tmp_list.append(i[index])
            index += 1

            if index == len(i) and len(tmp_list) < 4:
                print('no tetrahedron found.')
		#sort so that Cl is first then N
        tmp_list.sort(key = lambda x: x[0][0].specie.name)
        tet_name = ''
        for el in tmp_list:
            tet_name+= el[0][0].specie.name
        dictionary_of_Li_tetrahedra = {}
        dictionary_of_Li_tetrahedra['Li'] = my_srtucture[init+Li_counter]
        dictionary_of_Li_tetrahedra['tet'] = tmp_list
        dictionary_of_Li_tetrahedra['Li_number'] = Li_counter
        list_of_dictionary_of_Li_tetrahedra.append(dictionary_of_Li_tetrahedra)
        my_srtucture[Li_counter + init].properties['tet-dic'] = dictionary_of_Li_tetrahedra
        my_srtucture[Li_counter + init].properties['tet'] = tet_name
        Li_counter += 1


    #Do the same for octahedra

    list_of_Li_sites = [i for i, j in enumerate(my_srtucture) if j.specie.name == 'Na']
    init, end = list_of_Li_sites[0], list_of_Li_sites[-1]
    neighbors = my_srtucture.get_all_neighbors(dim, include_image=True)
    #print(init, end + 1)
    Li_neighbors = neighbors[init:end + 1]
    Li_counter = 0

    #global list_of_dictionary_of_Li_tetrahedra
    list_of_dictionary_of_Li_tetrahedra = []

    for li_index, i in enumerate(Li_neighbors):
        # sort to get the shortest distance first
        i.sort(key=lambda x: x[0][1])
        #global tmp_list
        tmp_list = []

        index = 0

        while len(tmp_list) != 6:

            if i[index][0].specie.name != "Li" and i[index][0].specie.name != 'Na':
                tmp_list.append(i[index])
            index += 1

            if index == len(i) and len(tmp_list) < 6:
                print('no octahedron found.')
            # sort so that N is first then S
        tmp_list.sort(key=lambda x: x[0][0].specie.name)
        tet_name = ''
        for el in tmp_list:
            tet_name += el[0][0].specie.name
        dictionary_of_Li_tetrahedra = {}
        dictionary_of_Li_tetrahedra['Li'] = my_srtucture[init+Li_counter]
        dictionary_of_Li_tetrahedra['oct'] = tmp_list
        dictionary_of_Li_tetrahedra['Li_number'] = Li_counter
        list_of_dictionary_of_Li_tetrahedra.append(dictionary_of_Li_tetrahedra)
        my_srtucture[Li_counter + init].properties['oct-dic'] = dictionary_of_Li_tetrahedra
        my_srtucture[Li_counter + init].properties['oct'] = tet_name
        Li_counter += 1

    return my_srtucture



import numpy as np


def truncate(num, n):
    integer = int(num * (10**n))/(10**n)
    return float(integer)

def make_coordinates_positive(a,b):
    new_a = []
    for i in a:
        if i<0:
            new_a.append(truncate(1+i,4))
        elif i>1:
            new_a.append(truncate(i-1,4))
        else:
            new_a.append(truncate(i,4))
    new_b = []
    for i in b:
        if i<0:
            new_b.append(truncate(1+i,4))
        elif i>1:
            new_b.append(truncate(i-1,4))
        else:
            new_b.append(truncate(i,4))
    return np.array(new_a), np.array(new_b)


def make_pair_dictionary_tet_tet(input_structure, tet_start_index=32, tet_end_index=96, for_percolation=False):
    dictionary_of_neighbouring_tet = {}
    input_structure=copy.deepcopy(input_structure)
    for i in range(tet_start_index, tet_end_index):
        for j in range(tet_start_index, tet_end_index):
            #print(np.linalg.norm(input_structure[i].coords-input_structure[j].coords))
            if i == j:
                pass
            elif np.linalg.norm(input_structure[i].coords-input_structure[j].coords) ==0 or  np.linalg.norm(input_structure[i].coords-input_structure[j].coords) > 5:
                pass
            # elif for_percolation and np.linalg.norm(input_structure[i].coords-input_structure[j].coords) > 5:
            #     pass
            else:
                #print('Tina')
                one = input_structure[i].properties['tet-dic']['tet']
                two = input_structure[j].properties['tet-dic']['tet']
                #print('got here')
                shared_sites = []
                for a in one:
                    for b in two:
                        p, v = make_coordinates_positive(a.frac_coords, b.frac_coords)
                        test_same = p == v
                        if False in test_same:
                            pass
                        else:
                            shared_sites.append(a)

                if len(shared_sites) == 2:
                    test_string = shared_sites[0].specie.name + shared_sites[1].specie.name
                    # if 'S' and 'N' in test_string:
                    #     value = 'SN'
                    # if 'S' not in test_string:
                    #     value = 'NN'
                    # if 'N' not in test_string:
                    #     value = 'SS'
                    value = ''.join(sorted(test_string))
                    key = (i, j)
                    tmp_dict = {}
                    tmp_dict['jump_type'] ='tet-tet'
                    tmp_dict['jump_type_precise'] =input_structure[i].properties['tet'] + '-'+input_structure[j].properties['tet']+'--'+value
                    tmp_dict['BN']=value
                    tmp_dict['shared_sites']=shared_sites
                    dictionary_of_neighbouring_tet[key] = tmp_dict
    return dictionary_of_neighbouring_tet

def make_pair_dictionary_oct_tet(input_structure, oct_start_index = 0, oct_end_index = 32, tet_start_index=32, tet_end_index = 96):
    dictionary_of_neighbouring_oct_tet = {}
    input_structure = copy.deepcopy(input_structure)
    for i in range(oct_start_index, oct_end_index):
        for j in range(tet_start_index, tet_end_index):
            if i == j:
                pass
            elif np.linalg.norm(input_structure[i].coords-input_structure[j].coords) ==0 or np.linalg.norm(input_structure[i].coords-input_structure[j].coords) > 5:
                pass
            else:
                one = input_structure[i].properties['oct-dic']['oct']
                two = input_structure[j].properties['tet-dic']['tet']
                #print('got here')
                shared_sites = []
                for a in one:
                    for b in two:
                        p, v = make_coordinates_positive(a.frac_coords, b.frac_coords)
                        test_same = p == v
                        if False in test_same:
                            pass
                        else:
                            shared_sites.append(a)

                if len(shared_sites) == 3:
                    test_string = shared_sites[0].specie.name + shared_sites[1].specie.name + shared_sites[2].specie.name
                    # if 'S' and 'N' in test_string:
                    #     value = 'S-N'
                    # if 'S' not in test_string:
                    #     value = 'N-N'
                    # if 'N' not in test_string:
                    #     value = 'S-S'
                    value = ''.join(sorted(test_string))
                    key = (i, j)
                    tmp_dict = {}
                    tmp_dict['jump_type'] ='oct-tet'
                    tmp_dict['jump_type_precise'] =input_structure[i].properties['oct'] + '-'+input_structure[j].properties['tet']+'--'+value
                    tmp_dict['BN']=value
                    tmp_dict['shared_sites']=shared_sites
                    dictionary_of_neighbouring_oct_tet[key] = tmp_dict


    return dictionary_of_neighbouring_oct_tet


def make_pair_dictionary_tet_oct(input_structure, oct_start_index = 0, oct_end_index = 32, tet_start_index=32, tet_end_index = 96):
    dictionary_of_neighbouring_tet_oct = {}
    input_structure = copy.deepcopy(input_structure)
    for i in range(tet_start_index, tet_end_index):
        for j in range(oct_start_index, oct_end_index):
            if i == j:
                pass
            elif np.linalg.norm(input_structure[i].coords-input_structure[j].coords) ==0 or np.linalg.norm(input_structure[i].coords-input_structure[j].coords) > 5:
                pass
            else:
                one = input_structure[i].properties['tet-dic']['tet']
                two = input_structure[j].properties['oct-dic']['oct']
                #print('got here')
                shared_sites = []
                for a in one:
                    for b in two:
                        p, v = make_coordinates_positive(a.frac_coords, b.frac_coords)
                        test_same = p == v
                        if False in test_same:
                            pass
                        else:
                            shared_sites.append(a)

                if len(shared_sites) == 3:
                    test_string = shared_sites[0].specie.name + shared_sites[1].specie.name + shared_sites[2].specie.name
                    # if 'S' and 'N' in test_string:
                    #     value = 'S-N'
                    # if 'S' not in test_string:
                    #     value = 'N-N'
                    # if 'N' not in test_string:
                    #     value = 'S-S'
                    value = ''.join(sorted(test_string))
                    key = (i, j)
                    tmp_dict = {}
                    tmp_dict['jump_type'] ='tet-oct'
                    tmp_dict['jump_type_precise'] =input_structure[i].properties['tet'] + '-'+input_structure[j].properties['oct']+'--'+value
                    tmp_dict['BN']=value
                    tmp_dict['shared_sites']=shared_sites
                    dictionary_of_neighbouring_tet_oct[key] = tmp_dict

    return dictionary_of_neighbouring_tet_oct



def make_pair_dictionary_oct_oct(input_structure, oct_start_index = 0, oct_end_index = 32):
    dictionary_of_neighbouring_oct_oct = {}
    input_structure = copy.deepcopy(input_structure)
    for i in range(oct_start_index, oct_end_index):
        for j in range(oct_start_index, oct_end_index):
            if i == j:
                pass
            else:
                one = input_structure[i].properties['oct-dic']['oct']
                two = input_structure[j].properties['oct-dic']['oct']
                #print('got here')
                shared_sites = []
                for a in one:
                    for b in two:
                        p, v = make_coordinates_positive(a.frac_coords, b.frac_coords)
                        test_same = p == v
                        if False in test_same:
                            pass
                        else:
                            shared_sites.append(a)

                if len(shared_sites) == 2:
                    test_string = shared_sites[0].specie.name + shared_sites[1].specie.name
                    # if 'S' and 'N' in test_string:
                    #     value = 'S-N'
                    # if 'S' not in test_string:
                    #     value = 'N-N'
                    # if 'N' not in test_string:
                    #     value = 'S-S'
                    value = ''.join(sorted(test_string))
                    key = (i, j)
                    tmp_dict = {}
                    tmp_dict['jump_type'] ='oct-oct'
                    tmp_dict['jump_type_precise'] =input_structure[i].properties['oct'] + '-'+input_structure[j].properties['oct']+'--'+value
                    tmp_dict['BN']=value
                    tmp_dict['shared_sites']=shared_sites
                    dictionary_of_neighbouring_oct_oct[key] = tmp_dict

    return dictionary_of_neighbouring_oct_oct

import pickle as pkl
import pymatgen
from pymatgen.io.vasp.outputs import Vasprun
import pickle
import numpy as np
import os

def find_more_accurate_site_positions(frac_coords_for_Li, input_structure):
    input_structure = copy.deepcopy(input_structure)
    frac_coords_for_Li = np.array(frac_coords_for_Li)
    hist_Li, binedges_Li = np.histogramdd(frac_coords_for_Li, bins=40, range=((0, 1), (0, 1), (0, 1)))
    binedges = binedges_Li
    x_coords = [binedges[0][i] - (binedges[0][i] - binedges[0][i - 1]) / 2 for i in range(1, len(binedges[0]))]
    y_coords = [binedges[1][i] - (binedges[1][i] - binedges[1][i - 1]) / 2 for i in range(1, len(binedges[1]))]
    z_coords = [binedges[2][i] - (binedges[2][i] - binedges[2][i - 1]) / 2 for i in range(1, len(binedges[2]))]

    list_with_all_four_coordinates_arrays = []
    hist = hist_Li
    for x in range(len(hist)):
        for y in range(len(hist[0])):
            for z in range(len(hist[0][0])):
                x_coordinate = x_coords[x]
                y_coordinate = y_coords[y]
                z_coordinate = z_coords[z]
                density = hist[x][y][z]
                # density_normalized = hist_normalized[x][y][z]
                list_with_all_four_coordinates_arrays.append(
                    np.array([x_coordinate, y_coordinate, z_coordinate, density]))

    for v in list_with_all_four_coordinates_arrays:
        if float(v[3]) > 0:
            input_structure.append('V', v[:3], coords_are_cartesian=False,properties={'weight': float(v[3])})

    neighbors = input_structure.get_all_neighbors(5, include_image=True,sites=input_structure[0:96])

    perfect_site_index_real_coordinates = []
    for li_index, i in enumerate(neighbors):
        i.sort(key=lambda x: x[0][1])
        truncated_i = [j[0].properties['weight'] for j in i if j[0][1] <= 0.5]
        max_index = truncated_i.index(max(truncated_i))
        perfect_site_index_real_coordinates.append(
            [li_index, input_structure[li_index].frac_coords, i[max_index].frac_coords])
        #
        # print(len(i))
        # print(len(truncated_i))

    input_structure.remove_species(['V'])
    for i, j in enumerate(input_structure[:96]):
        j.frac_coords = perfect_site_index_real_coordinates[i][-1]

    site_coordinates = ''

    site_names = ''

    def make_frac_coords_positive(a):
        new_a = [1 + i if i < 0 else i for i in a]
        return np.array(new_a)

    site_coordinates = ''

    site_names = ''

    for i, site in enumerate(input_structure[:96]):
        tmp_string = ''
        tmp_frac_coords = make_frac_coords_positive(site.frac_coords)
        for c in tmp_frac_coords:
            tmp_string += str(c) + ' '
        tmp_string += '; '
        site_coordinates += tmp_string

        tmp_string = ""

        if i < 32:
            tmp_string += "'" + site.properties['oct'] + "'" + ', '
            site_names += tmp_string
        else:
            tmp_string += "'" + site.properties['tet'] + "'" + ', '
            site_names += tmp_string

    # print(site_coordinates)
    # print(site_names)
    return site_coordinates, site_names, input_structure



def get_list_of_all_jumps(composition,T, total_steps=98751, directory = 'files_for_analysis'):
    k_b = 8.617333E-5  # eV K
    d = directory
    with open(d+'\\structure_with_polyhedra_analyzed_supercell_1.pkl', 'rb') as f:
        tmp_supercell = pkl.load(f)


    with open(d+'\\combined_dict.pkl', 'rb') as f:
        all_connections = pkl.load(f)

    #Get the transitions matrix
    matrix_1c5A = pandas.read_excel(d+'\\transitions_1c5A.xlsx', header=None).values
    matrix_2A = pandas.read_excel(d+'\\transitions_2A.xlsx', header=None).values

    occupancy_1c5A,  occupancy_2A= pandas.read_excel(d+'\\occupancy_1c5A.xlsx', header=None).values, pandas.read_excel(d+'\\occupancy_2A.xlsx', header=None).values


    fractional_occ_time_1c5A, fractional_occ_time_2A  = [i[0]/(total_steps) for i in occupancy_1c5A], [i[0]/(total_steps) for i in occupancy_2A] #the fractional time needs to be also divided by the number of atoms

    dict_of_jump_types = {(True, True): 'tet-tet', (True, False): 'tet-oct', (False, True): 'oct-tet',
                          (False, False): 'oct-oct'}
    list_of_jumps = []
    def get_list(matrix, fractional_occ_time, radius):
        dict_of_jump_types = {(True, True): 'tet-tet', (True, False): 'tet-oct', (False, True): 'oct-tet',
                              (False, False): 'oct-oct'}
        for index_1, row in enumerate(matrix):
            for index_2, v in enumerate(row):
                if v != 0:
                    try:
                        tmp_key = tuple([index_1, index_2])
                        e_a = -k_b * T * np.log(v / (fractional_occ_time[index_1] * total_steps * 2 * 1E-15 * 1.0E13))
                        list_of_jumps.append({'indices': tmp_key, 'e_a':e_a, 'site_radius': radius, 'composition':composition, **all_connections[tmp_key]})
                    except:
                        pass

    get_list(matrix_1c5A, fractional_occ_time_1c5A, '1c5A')
    get_list(matrix_2A, fractional_occ_time_2A, '2A')

    return list_of_jumps

tmp_dict = {}
# def sort_list_of_jumps_by_jump_type_and_BN(list_of_jumps):
#     for i in list_of_jumps:
#         tmp_dict[i['jump_type']] = {i['BN']:[], **tmp_dict[i['jump_type']]}
#     for i in list_of_jumps:
#         tmp_dict[i['jump_type']][i['BN']].append(i['e_a'])
#     return tmp_dict

def get_jumps_sorted_by_jump_type(list_of_jumps):
    all_jump_types = set([i['jump_type_precise'] for i in list_of_jumps])
    dict_of_individual_jump_types = {}
    for i in all_jump_types:
        dict_of_individual_jump_types[i] = {'activation_energies': [], 'average_ea': None, 'error_in_ea': None,
                                            'BN': None, 'jump_type': None}

    for i in list_of_jumps:
        dict_of_individual_jump_types[i['jump_type_precise']]['activation_energies'] += [i['e_a']]
        dict_of_individual_jump_types[i['jump_type_precise']]['BN'] = i['BN']
        dict_of_individual_jump_types[i['jump_type_precise']]['jump_type'] = i['jump_type']

    for k, v in dict_of_individual_jump_types.items():
        v['average_ea'] = np.average(v['activation_energies'])
        v['error_in_ea'] = np.std(v['activation_energies']) / np.sqrt(len(v['activation_energies']))

    return dict_of_individual_jump_types


def sort_jumps_by_type_and_bottleneck(list_of_jumps):
    set_of_bottlenecks = set([i['BN'] for i in list_of_jumps])
    sub_dict = {}
    for i in set_of_bottlenecks:
        sub_dict[i] = {'activation_energies':[], 'average_e_a':None, 'average_e_a_error':None}
    dict = {'tet-tet':copy.deepcopy(sub_dict), 'tet-oct':copy.deepcopy(sub_dict), 'oct-tet':copy.deepcopy(sub_dict), 'oct-oct':copy.deepcopy(sub_dict)}

    for i in list_of_jumps:
        dict[i['jump_type']][i['BN']]['activation_energies'].append(i['e_a'])
    for k, v in dict.items():
        for k2,v2 in v.items():
            if len(v2['activation_energies'])>0:
                #print('ye])')
                v2['average_ea'] = np.average(v2['activation_energies'])
                v2['error_in_ea'] = np.std(v2['activation_energies']) / np.sqrt(len(v2['activation_energies']))

    return dict